//***********************************************************************//
//***********************************************************************//
//*                                          Parabolic (Open_Close).mq4 *//
//*                                         Copyright  2009, BACKSPACE *//
//*                                           Updating from 10.02.2010  *//
//***********************************************************************//
//***********************************************************************//
//*                                                         *//
//*                                                       *//
//*                                                    *//
//*                                                      *//
//***********************************************************************//
//***********************************************************************//
#property copyright "Copyright  2009, BACKSPACE"                        //
#property link      "Updating from 10.02.2010 "                          //
//
#property indicator_chart_window                                         //
#property indicator_buffers 1                                            //
#property indicator_color1 Red                                           //
//******************//   
extern double Max=0.009;                                                 //   -   Parabolic
extern double Step=0.005;                                                //   -   Parabolic
                                                                         //******************//   
double ParabolicSAR[],                                                   //   - Parabolic SAR
ParAle[],                                                         //   -  Parabolic
HHigh,                                                            //   -   
LLow,                                                             //   -   
HHighPP,                                                          //   - Previous Point HHigh
LLowPP;                                                           //   - Previous Point LLow
                                                                  //******************//  
int    Counter;                                                          //   -  
double IndexHL=1,                                                        //   -   
ExtremumLong,                                                     //   -  High
ExtremumShort;                                                    //   -  Low
string Typ="Short";                                                      //   -  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
                                                                         //***********************************************************************//
//**********************-Indicator Initialization-***********************//
//***********************************************************************//
//
int init()                                                               //
  {                                                  //******************//   
   IndicatorBuffers(2);                                                  //
   SetIndexLabel(0,"ParabolicSAR");                                      //
   SetIndexStyle(0,DRAW_ARROW);                                          //
   SetIndexArrow(0,159);                                                 //
   SetIndexBuffer(0,ParabolicSAR);                                       //
   SetIndexBuffer(1,ParAle);                                             //
                                                                         //*********//
   return(0);                                                            //
  }                                                                      //
//***********************************************************************//
//*************************-Moving Rounding Off-*************************//
//***********************************************************************//
//
int start()                                                              //
  {                                                                      //
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit-=2;

   for(int mr=limit; mr>=1; mr--) //
     {                                                                   //
      Bars_High_Low_Init(mr);                        //******************//  High/Low
      Parabolic_SAR(mr);                             //******************//  Parabolic SAR
      Extremum_Long_Short(mr);                       //******************//  Long/Short
     }                                                                   //
//*********//
   return(0);                                                            //
  }                                                                      //
//***********************************************************************//
//******************************-SubPogramms-****************************//
//***********************************************************************//
//
//***********************************//  High/Low 
double Bars_High_Low_Init(int bhli)                                      //
  {                                                                      //
   if(iOpen(NULL,0,bhli)>iClose(NULL,0,bhli))                            //
     {                                                                   //
      HHigh =iOpen(NULL,0,bhli);                                         //
      LLow  =iClose(NULL,0,bhli);                                        //
     }                                                                   //
   else if(iOpen(NULL,0,bhli)<iClose(NULL,0,bhli))                       //
     {                                                                   //
      HHigh =iClose(NULL,0,bhli);                                        //
      LLow  =iOpen(NULL,0,bhli);                                         //
     }                                                                   //
   else                                                                  //
     {                                                                   //
      HHigh =iClose(NULL,0,bhli);                                        //
      LLow  =iOpen(NULL,0,bhli);                                         //
     }                                                                   //
//*********//
   return(0);                                                            //
  }                                                                      //
//***********************************//  Parabolic SAR
double Parabolic_SAR(int ps)                                             //
  {                                                                      //
   if(Typ=="Long")                                                       //
     {                                                                   //
      if(LLow<=ParabolicSAR[ps+1]) //******************//   -   Short
        {                                                                //
         Typ="Short";                                                    //
         ParabolicSAR[ps]=ExtremumLong;                                  //
         ExtremumShort=LLow;                                             //
         IndexHL=1;                                                      //
         ParAle[ps]=-1;                                                  //
         return(0);                                                      //
        }                                                                //
      else                                           //******************//   -   Long
        {                                                                //
         ParabolicSAR[ps]=ParabolicSAR[ps+1]+                            //
                          (Max+IndexHL*Step)*(HHighPP-ParabolicSAR[ps+1]);                 //
         if(HHigh>ExtremumLong)                                          //   -   
            IndexHL++;                                                    //
         HHighPP=HHigh;                                                  //
         ParAle[ps]=ParAle[ps+1];                                        //
         return(0);                                                      //
        }                                                                //
     }                                                                   //
   if(Typ=="Short")                                                      //
     {                                                                   //
      if(HHigh>=ParabolicSAR[ps+1]) //******************//   -   Long
        {                                                                //
         Typ="Long";                                                     //
         ParabolicSAR[ps]=ExtremumShort;                                 //
         ExtremumLong=HHigh;                                             //
         IndexHL=1;                                                      //
         ParAle[ps]=1;                                                   //
         return(0);                                                      //
        }                                                                   //
      else                                           //******************//   -   Short
        {                                                                //
         ParabolicSAR[ps]=ParabolicSAR[ps+1]-                            //
                          (Max+IndexHL*Step)*(ParabolicSAR[ps+1]-LLowPP);                  //
         if(LLow<ExtremumShort)                                          //   -   
            IndexHL++;                                                    //
         LLowPP=LLow;                                                    //
         ParAle[ps]=ParAle[ps+1];                                        //
         return(0);                                                      //
        }                                                                //
     }                                                                   //
//*********//
   return(0);                                                            //
  }                                                                      //
//***********************************//  Long/Short
double Extremum_Long_Short(int ehl)                                      //
  {                                                                      //
   if(HHigh>ExtremumLong) //******************//   -  Long
      ExtremumLong=HHigh;                                                 //
   if(LLow<ExtremumShort) //******************//   -  Short
      ExtremumShort=LLow;                                                 //
//*********//
   return(0);                                                            //
  }                                                                      //
//***********************************************************************//
//********************************************************************BS*//
//***********************************************************************//
